/// @access private
/// @link https://www.oddbird.net/accoutrement/docs/type.html
$fonts: (
	'sans': (
		'name': 'Akkurat',
		'formats': 'woff' 'woff2',
		'stack': (
			'Helvetica',
			'Arial',
			sans-serif,
		),
		'normal': '~assets/fonts/akkurat/lineto-akkurat-pro-regular',
		'italic': '~assets/fonts/akkurat/lineto-akkurat-pro-italic',
		'300': '~assets/fonts/akkurat/lineto-akkurat-pro-light',
		'300 italic': '~assets/fonts/akkurat/lineto-akkurat-pro-lightitalic',
		'700': '~assets/fonts/akkurat/lineto-akkurat-pro-bold',
		'700 italic': '~assets/fonts/akkurat/lineto-akkurat-pro-bolditalic',
	),
	'serif': (
		'name': 'Plantin',
		'formats': 'woff' 'woff2',
		'stack': (
			'Arial',
			serif,
		),
		'normal': '~assets/fonts/plantin/30BBC3_0_0',
		'italic': '~assets/fonts/plantin/30BBD6_0_0',
	),
	'primary': '#sans',
	'secondary': '#serif',
);

/// @access private
/// @see $fonts - For list of 'font' names.
/// /* 1rem = 10px */
$typography: (
	'body': (
		'font': 'primary',
		'size': 62.5%,
		'height': 1.3,
		'weight': normal,
	),
	'type': (
		'height': 1.6,
	),
	'type-100': (
		'size': 1.4rem,
	),
	'type-200': (
		'size': 1.6rem,
	),
	'type-300': (
		'size': 1.5rem,
	),
	'type-400': (
		'size': 1.2rem,
	),
	'type-500': (
		'size': 1.8rem,
	),
	'heading': (
		'height': 1.1,
		'weight': normal,
	),
	'heading-100': (
		'size': 2rem,
		'height': 2.5rem,
	),
	'heading-150': (
		'size': 2.2rem,
		'height': 3rem,
	),
	'heading-180': (
		'size': 2.4rem,
		'height': 1.25,
	),
	'heading-200': (
		'size': 2.5rem,
		'height': 3rem,
	),
	'heading-300': (
		'size': 2.8rem,
		'height': 3.4rem,
	),
	'heading-400': (
		'size': 3rem,
		'height': 3.5rem,
	),
	'heading-410': (
		'size': 3rem,
		'height': 3.6rem,
		'weight': 300,
	),
	'heading-420': (
		'size': 3rem,
		'height': 4rem,
		'weight': 300,
	),
	'heading-500': (
		'size': 3.5rem,
	),
	'heading-600': (
		// to remove
			'size': 3.6rem,
	),
	'heading-650': (
		'size': 3.8rem,
	),
	'heading-700': (
		'size': 4.5rem,
	),
	'heading-800': (
		// to remove
			'size': 5rem,
	),
	'heading-900': (
		'size': 6rem,
		'height': 1.33333,
	),
);

/// Set text style.
/// @param {string} $token - One of keys of $typography map above.
@mixin use-text-style($token: 'body') {
	$type: get-token($typography, $token);

	@if (get-token($type, 'font') != 'font') {
		@if ($can-use-css-variables) {
			font-family: var-font(get-token($type, 'font'), $fallback: false);
		} @else {
			font-family: font-family(get-token($type, 'font'));
		}
	}

	@if (get-token($type, 'size') != 'size') {
		font-size: get-token($type, 'size');
	}

	@if (get-token($type, 'weight') != 'weight') {
		font-weight: get-token($type, 'weight');
	}

	@if (get-token($type, 'height') != 'height') {
		line-height: get-token($type, 'height');
	}
}

// Override a internal mixin to add font-display support
// Source: https://github.com/oddbird/accoutrement/blob/5b674faa4d68db2413c282267ffd51ce69032ce5/sass/plugin/type/_helpers.scss#L289
// Removed eot related stuff
@mixin _a_import-font-face($name, $weight, $style, $data, $unicode: null) {
	// Format values for CSS
	$name: quote($name);
	$style: unquote($style);
	$weight: unquote($weight);

	@if $unicode {
		$new: ();

		@each $code in $unicode {
			$new: append($new, unquote($code), 'comma');
		}

		$unicode: $new;
	}

	@font-face {
		font-family: $name;
		font-style: $style;
		font-weight: $weight;
		font-display: swap;
		src: _a_font-src-list($data);
		unicode-range: $unicode;
	}
}
